/*******************************************************************************
 *	@file			Suuji.cpp
 *	@brief			ō
 *
 *	@date			01-May-2011(Sun)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "DL.h"
#include "DLGraph.h"
#include "DLSound.h"
#include "DLInput.h"
#include "DLDebug.h"

#ifdef _DEBUG
#pragma comment ( lib, "Debug\\_DXLibv2.lib" )
#else	// _DEBUG
#pragma comment ( lib, "Release\\_DXLibv2.lib" )
#endif	// _DEBUG

// 񋓌^`-------------------------------------------------------------------

// \̒`-------------------------------------------------------------------

// O[oϐ-----------------------------------------------------------
static const char* const APPNAME	= "";									//!< Av̖O
static const int APPWIDTH			= 640;										//!< Av̏
static const int APPHEIGHT			= 480;										//!< Av̏
static const float FRAMERATE		= 33.33333333333f;							//!< t[[g
static const int BASE_NUM			= 4;
static const int END_NUM			= 5;

DL::CDLGraph*			g_pGraph;												//!< DirectX Graphics
DL::CDLSound*			g_pSound;												//!< DirectX Sound
DL::CDLInput*			g_pInput;												//!< DirectX Input
DL::CDLDebug*			g_pDebug;

BOOL					g_bProg = TRUE;

HANDLE					g_hMutex = NULL;										//!< Lnh
HWND					g_hWnd = NULL;											//!< EChEnh

BYTE					g_byKey[ DL::CDLInput::KEYBUFFER_MAX ];					//!< L[obt@
DIMOUSESTATE			g_DIMS;
POINT					g_ptMouse;

// -----------------------------------------------------------------------------
enum eGameState
{
	eGameState_None		= 0,													//!< ɂȂ
	eGameState_Scale,															//!< g
	eGameState_Move,															//!< ړ
	eGameState_Rotate,															//!< ]
};

static const int		SUUJI_WIDTH		= 320;
static const int		SUUJI_HEIGHT	= 320;

int						g_nAreaX;												//!< ͈͂w
int						g_nAreaY;												//!< ͈͂x
int						g_nAreaW;												//!< ͈͂v
int						g_nAreaH;												//!< ͈͂g

int						g_nCurNum;												//!< J[\ԍ
int						g_nBGNum;												//!< wiԍ
int						g_nFontNum;												//!< tHgԍ

int						g_nAryNum[ 20 ];										//!< ̓ꕨiO|PXj
int						g_nGmNum[ 10 ];											//!< Q[Ŏgp鐔̓ꕨiőPOj
int						g_nNumMax;												//!< Q[Ŏgp鐔̐

int						g_nGameCnt;												//!< Q[̃JEg
int						g_nGameTimer;											//!< ^C}[

int						g_nMov[ 10 ][ 2 ];										//!< ړp
int						g_nRot[ 10 ];											//!< ]p

// ֐vg^Cv錾-----------------------------------------------------
void Create( void );															//!< 쐬
void GetArea( const DL::D3DDATA* pData, float& fXL, float& fXR, float& fYU, float& fYD );	//!< ͈͎擾
void Game( void );																//!< Q[
void Draw( void );																//!< `

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				void Create( void )
 *	@retval			none
 *	@brief			쐬
 ******************************************************************************/
void Create( void )
{
	int nNum = BASE_NUM + g_nGameCnt;
	int nNumAry[ 50 ];
	// 
	for( int i = 0; i < 50; i++ )
		nNumAry[ i ] = i % nNum;
	// ւ
	for( int i = 0; i < 32767; i++ )
	{
		::srand( ::timeGetTime() + i );
		int n1 = ::rand() % 50;
		::srand( ::timeGetTime() + n1 );
		int n2 = ::rand() % 50;

		int nTmp = nNumAry[ n1 ];
		nNumAry[ n1 ] = nNumAry[ n2 ];
		nNumAry[ n2 ] = nTmp;
	}
	// ōݒi蔲j
	{
		::srand( ::timeGetTime() );
		g_nNumMax = ::rand() % nNum;
		nNumAry[ g_nNumMax ] = nNum;
	}
	// \ݒ
	for( int i = 0; i < nNum; i++ )
	{
		RECT rc;
		rc.left = i * 32; rc.top = 0; rc.right = i * 32 + 32; rc.bottom = 32;
		int nColor = 0xFF000000;
		g_pGraph->Del( 100 + i );
		g_nAryNum[ i ] = g_pGraph->AddRect( 100 + i, 20, 100 + nNumAry[ i ], DL::enumDraw_Off, DL::enumState_Translucent, rc, nColor );
	}
	// zuݒ
	for( int i = 0; i < nNum; i++ )
	{
		DL::D3DOBJECT *m_pD3DObj = g_pGraph->GetObject( g_nAryNum[ i ] );
		m_pD3DObj->m_eDraw = DL::enumDraw_On;

		DL::D3DDATA* pData = static_cast<DL::D3DDATA*>( m_pD3DObj->m_pObj );

		DL::D3DVERTEX* v0 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 0 ] );
		DL::D3DVERTEX* v1 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 1 ] );
		DL::D3DVERTEX* v2 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 2 ] );
		DL::D3DVERTEX* v3 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 3 ] );

		::srand( ::timeGetTime() * i );
		int nX = ( SUUJI_WIDTH / nNum ) * ( i + 1 );
		nX %= ( g_nAreaW - g_nAreaX - 32 );
		int nY = ::rand() * 32;
		nY %= ( g_nAreaH - g_nAreaY - 32 );

		v0->x	= static_cast<float>( nX + g_nAreaX );
		v0->y	= static_cast<float>( nY + g_nAreaY );
		v1->x	= v0->x + 32;
		v1->y	= v0->y;
		v2->x	= v1->x;
		v2->y	= v1->y + 32;
		v3->x	= v0->x;
		v3->y	= v2->y;

		if( g_nGameCnt >= eGameState_Scale )		// QEg
		{
			v1->x	= v0->x + 32 + ( i * 2 );
			v2->x	= v1->x;
			v2->y	= v1->y + 32 + ( i * 2 );
			v3->y	= v2->y;
		}
		if( g_nGameCnt >= eGameState_Move )			// REړ
		{
			g_nMov[ i ][ 0 ] = g_nMov[ i ][ 1 ] = ( i % 2 == 0 ) ? (-g_nGameCnt) : g_nGameCnt;
		}
		if( g_nGameCnt >= eGameState_Rotate )		// SE]
		{
			g_nRot[ i ] = i / 2 + 1;
		}
	}
}

void GetArea( const DL::D3DDATA* pData, float& fXL, float& fXR, float& fYU, float& fYD )
{
	DL::D3DVERTEX* v0 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 0 ] );
	DL::D3DVERTEX* v1 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 1 ] );
	DL::D3DVERTEX* v2 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 2 ] );
	DL::D3DVERTEX* v3 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 3 ] );

	// wW
	fXL = v0->x;
	if( fXL > v1->x ) fXL = v1->x;
	if( fXL > v2->x ) fXL = v2->x;
	if( fXL > v3->x ) fXL = v3->x;
	// EwW
	fXR = v0->x;
	if( fXR < v1->x ) fXR = v1->x;
	if( fXR < v2->x ) fXR = v2->x;
	if( fXR < v3->x ) fXR = v3->x;
	// xW
	fYU = v0->y;
	if( fYU > v1->y ) fYU = v1->y;
	if( fYU > v2->y ) fYU = v2->y;
	if( fYU > v3->y ) fYU = v3->y;
	// xW
	fYD = v0->y;
	if( fYD < v1->y ) fYD = v1->y;
	if( fYD < v2->y ) fYD = v2->y;
	if( fYD < v3->y ) fYD = v3->y;
}

/*******************************************************************************
 *	@fn				void Game( void )
 *	@retval			none
 *	@brief			Q[
 ******************************************************************************/
void Game( void )
{
	int nNum = BASE_NUM + g_nGameCnt;
	for( int i = 0; i < nNum; i++ )
	{
		DL::D3DOBJECT *m_pD3DObj = g_pGraph->GetObject( g_nAryNum[ i ] );
		DL::D3DDATA* pData = static_cast<DL::D3DDATA*>( m_pD3DObj->m_pObj );

		DL::D3DVERTEX* v0 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 0 ] );
		DL::D3DVERTEX* v1 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 1 ] );
		DL::D3DVERTEX* v2 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 2 ] );
		DL::D3DVERTEX* v3 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 3 ] );

		float fXL = 0.0f, fXR = 0.0f, fYU = 0.0f, fYD = 0.0f;
		GetArea( pData, fXL, fXR, fYU, fYD );

		if( g_nGameCnt >= eGameState_Move )			// REړ
		{
			if( g_nAreaX >= fXL ) g_nMov[ i ][ 0 ] *= (-1);
			if( g_nAreaW <= fXR ) g_nMov[ i ][ 0 ] *= (-1);
			if( g_nAreaY >= fYU ) g_nMov[ i ][ 1 ] *= (-1);
			if( g_nAreaH <= fYD ) g_nMov[ i ][ 1 ] *= (-1);

			v0->x += g_nMov[ i ][ 0 ]; v1->x += g_nMov[ i ][ 0 ]; v2->x += g_nMov[ i ][ 0 ]; v3->x += g_nMov[ i ][ 0 ];
			v0->y += g_nMov[ i ][ 1 ]; v1->y += g_nMov[ i ][ 1 ]; v2->y += g_nMov[ i ][ 1 ]; v3->y += g_nMov[ i ][ 1 ];
		}
		if( g_nGameCnt >= eGameState_Rotate )		// SE]
		{
			double dRad = g_nRot[ i ] * (3.14159265) / 180;

			float fCX = fXL + ( fXR - fXL ) / 2;
			float fCY = fYU + ( fYD - fYU ) / 2;

			float fX = v0->x;
			float fY = v0->y;
			v0->x = static_cast<float>( fCX + cos( dRad ) * ( fX - fCX ) - sin( dRad ) * ( fY - fCY ) );
			v0->y = static_cast<float>( fCY + sin( dRad ) * ( fX - fCX ) + cos( dRad ) * ( fY - fCY ) );
			fX = v1->x;
			fY = v1->y;
			v1->x = static_cast<float>( fCX + cos( dRad ) * ( fX - fCX ) - sin( dRad ) * ( fY - fCY ) );
			v1->y = static_cast<float>( fCY + sin( dRad ) * ( fX - fCX ) + cos( dRad ) * ( fY - fCY ) );
			fX = v2->x;
			fY = v2->y;
			v2->x = static_cast<float>( fCX + cos( dRad ) * ( fX - fCX ) - sin( dRad ) * ( fY - fCY ) );
			v2->y = static_cast<float>( fCY + sin( dRad ) * ( fX - fCX ) + cos( dRad ) * ( fY - fCY ) );
			fX = v3->x;
			fY = v3->y;
			v3->x = static_cast<float>( fCX + cos( dRad ) * ( fX - fCX ) - sin( dRad ) * ( fY - fCY ) );
			v3->y = static_cast<float>( fCY + sin( dRad ) * ( fX - fCX ) + cos( dRad ) * ( fY - fCY ) );
		}

		// \gɒ
		{
			if( g_nAreaX >= fXL )
			{
				float f = g_nAreaX - fXL;
				v0->x += f; v1->x += f; v2->x += f; v3->x += f;
			}
			if( g_nAreaW <= fXR )
			{
				float f = fXR - g_nAreaW;
				v0->x -= f; v1->x -= f; v2->x -= f; v3->x -= f;
			}
			if( g_nAreaY >= fYU )
			{
				float f = g_nAreaY - fYU;
				v0->y += f; v1->y += f; v2->y += f; v3->y += f;
			}
			if( g_nAreaH <= fYD )
			{
				float f = fYD - g_nAreaH;
				v0->y -= f; v1->y -= f; v2->y -= f; v3->y -= f;
			}
		}
	}

	// 蔻
	if( g_DIMS.rgbButtons[ 0 ] & 0x80 )
	{
		DL::D3DOBJECT *m_pD3DObj = g_pGraph->GetObject( g_nAryNum[ g_nNumMax ] );
		DL::D3DDATA* pData = static_cast<DL::D3DDATA*>( m_pD3DObj->m_pObj );
		float fXL = 0.0f, fXR = 0.0f, fYU = 0.0f, fYD = 0.0f;
		GetArea( pData, fXL, fXR, fYU, fYD );

		// 
		if( ( fXL <= g_ptMouse.x && g_ptMouse.x <= fXR )
		&&  ( fYU <= g_ptMouse.y && g_ptMouse.y <= fYD ) )
		{
			// 
			g_nGameCnt++;
			if( g_nGameCnt == END_NUM )
				g_bProg = FALSE;
			else
				Create();
		}
	}
}

/*******************************************************************************
 *	@fn				void Draw( void )
 *	@retval			none
 *	@brief			`
 ******************************************************************************/
void Draw( void )
{
	// J[\
	{
		DL::D3DOBJECT *m_pD3DObj = g_pGraph->GetObject( g_nCurNum );
		DL::D3DDATA* pData = static_cast<DL::D3DDATA*>( m_pD3DObj->m_pObj );

		DL::D3DVERTEX* v0 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 0 ] );
		DL::D3DVERTEX* v1 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 1 ] );
		DL::D3DVERTEX* v2 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 2 ] );

		v0->x = static_cast<float>( g_ptMouse.x + 0 );
		v0->y = static_cast<float>( g_ptMouse.y + 0 );
		v1->x = static_cast<float>( g_ptMouse.x + 20 );
		v1->y = static_cast<float>( g_ptMouse.y + 5 );
		v2->x = static_cast<float>( g_ptMouse.x + 5 );
		v2->y = static_cast<float>( g_ptMouse.y + 20 );
	}
}

/*******************************************************************************
 *	@fn				LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
 *	@retval			LRESULT
 *	@brief			EChEvV[W
 ******************************************************************************/
LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg )
	{
	case WM_DESTROY:															//!< EChE
		::PostQuitMessage( 0 );													//!< WM_QUIT𑗂
		return ::DefWindowProc( hWnd, msg, wParam, lParam );
	default :
		return ::DefWindowProc( hWnd, msg, wParam, lParam );
	}
	return ::DefWindowProc( hWnd, msg, wParam, lParam );
}

/*******************************************************************************
 *	@fn				int Init( const HINSTANCE& hInst )
 *	@param[in]		hInst			CX^Xnh
 *	@retval			int				EXIT_SUCCESS=OK/EXIT_FAILURE=NG
 *	@brief			AvP[V̏
 ******************************************************************************/
int Init( const HINSTANCE& hInst )
{
	// dŇ
	// L̊m
	g_hMutex = ::CreateMutex( NULL, FALSE, APPNAME );
	// Ľ
	if( ::WaitForSingleObject( g_hMutex, 0 ) != WAIT_OBJECT_0 )
	{
		_ASSERT( 0 && "WaitForSingleObject()" );
		::CloseHandle( g_hMutex );
		return EXIT_FAILURE;
	}

	// EChE
	WNDCLASS			wc;														//!< EChENX
	// EChENX̓o^
	wc.style				= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc			= static_cast<WNDPROC>( WndProc );					//!< bZ[W󂯎EChE֐
	wc.cbClsExtra			= 0;
	wc.cbWndExtra			= 0;
	wc.hInstance			= hInst;
	wc.hIcon				= NULL;												//!< ACRo^
	wc.hCursor				= ::LoadCursor( NULL, IDC_ARROW );					//!< J[\o^
	wc.hbrBackground		= static_cast<HBRUSH>( ::GetStockObject( WHITE_BRUSH ) );
	wc.lpszMenuName			= NULL;												//!< j[̓o^
	wc.lpszClassName		= APPNAME;
	// EChENX̓o^
	if( !::RegisterClass( &wc ) ) return EXIT_FAILURE;

	int nSizeX = APPWIDTH;
	int nSizeY = APPHEIGHT;
	int nPosX = ( ::GetSystemMetrics( SM_CXSCREEN ) - nSizeX ) / 2;;
	int nPosY = ( ::GetSystemMetrics( SM_CYSCREEN ) - nSizeY ) / 2;;
	// EChE쐬
	g_hWnd = ::CreateWindow( APPNAME,											//!< NX
							 APPNAME,											//!< ^Cg
							 WS_POPUP,											//!< X^C( WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU )
							 nPosX,												//!< wW
							 nPosY,												//!< xW
							 nSizeX,											//!< 
							 nSizeY,											//!< 
							 NULL,												//!< eEChẼnh
							 NULL,												//!< j[nh
							 hInst,												//!< CX^Xnh
							 NULL );											//!< lParam

	// EChE̍쐬
	if( !g_hWnd ) return EXIT_FAILURE;
	// EChE̕\Ԃ̐ݒ
	::ShowWindow( g_hWnd, SW_SHOW );
	// EChE̍XV
	::UpdateWindow( g_hWnd );

	return EXIT_SUCCESS;
}

/*******************************************************************************
 *	@fn				int Exit( void )
 *	@retval			int				EXIT_SUCCESS=OK/EXIT_FAILURE=NG
 *	@brief			AvP[V̏I
 ******************************************************************************/
int Exit( void )
{
	if( g_hWnd != NULL )
	{
		::DestroyWindow( g_hWnd );
		g_hWnd = NULL;
		::UnregisterClass( APPNAME, NULL );
	}
	if( g_hMutex != NULL ){ ::CloseHandle( g_hMutex ); g_hMutex = NULL; }
	return EXIT_SUCCESS;
}

/*******************************************************************************
 *	@fn				BOOL ProcessEvent( void )
 *	@retval			BOOL			TRUE=OK/FALSE=NG
 *	@brief			Cxg̎s
 ******************************************************************************/
BOOL ProcessEvent( void )
{
	MSG	msg;
	if( !g_bProg ) return FALSE;
	// botLPOOŎgpBɂ̃AvŗDŎgp
	while( ::PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
	{
		if( !::GetMessage( &msg, NULL, 0, 0 ) )
			return FALSE;
		::TranslateMessage( &msg );
		::DispatchMessage( &msg );
	}
	return TRUE;
}

/*******************************************************************************
 *	@fn				BOOL Init( void )
 *	@retval			BOOL			TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
BOOL Init( void )
{
	// gpNX̐ݒƎ擾
	g_pGraph = reinterpret_cast<DL::CDLGraph*>( DL::SetupGraph( APPWIDTH, APPHEIGHT, TRUE ) );
	g_pSound = reinterpret_cast<DL::CDLSound*>( DL::SetupSound( TRUE ) );
	g_pInput = reinterpret_cast<DL::CDLInput*>( DL::SetupInput() );
	g_pDebug = reinterpret_cast<DL::CDLDebug*>( DL::SetupDebug() );

	// 
	DL::Init( g_hWnd, FRAMERATE );

	// J[\
	{
		DL::D3DVERTEX SCursor[ 3 ] =
		{
			{  0.0f,  0.0f, 0.0f, 1.0f, 0xffffffff, 0.0f, 0.0f },
			{ 20.0f,  5.0f, 0.0f, 1.0f, 0xffffffff, 0.0f, 0.0f },
			{  5.0f, 20.0f, 0.0f, 1.0f, 0xffffffff, 0.0f, 0.0f },
		};
		g_nCurNum = 9;
		g_nCurNum = g_pGraph->AddVertex( g_nCurNum, 100, -1, DL::enumDraw_On, DL::enumState_Normal, 3, SCursor );
	}

	g_nAreaX = ( APPWIDTH - SUUJI_WIDTH ) / 2;
	g_nAreaY = ( APPHEIGHT - SUUJI_HEIGHT ) / 2;
	g_nAreaW = g_nAreaX + SUUJI_WIDTH;
	g_nAreaH = g_nAreaY + SUUJI_HEIGHT;

	// wi
	{
		RECT rc;
		rc.left		= g_nAreaX;
		rc.top		= g_nAreaY;
		rc.right	= g_nAreaW;
		rc.bottom	= g_nAreaH;
		g_nBGNum = 10;
		g_nBGNum = g_pGraph->AddRect( g_nBGNum, 10, -1, DL::enumDraw_On, DL::enumState_Normal, rc, 0xff888888 );
	}

	char* cNum[ 10 ] = { "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X" }; 
	// eNX`쐬
	for( int nNum = 0; nNum < 10; nNum++ )
	{
		// http://marupeke296.com/WINT_ExampleOfGetGlyphOutline.html
		GLYPHMETRICS gm;
		CONST MAT2 mat = { { 0, 1 }, { 0, 0 }, { 0, 0 }, { 0, -1 } };
		HFONT hFont = ::CreateFont( 24, 0, 0, 0, 0,
			FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_TT_ONLY_PRECIS,
			CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH | FF_MODERN, "lr SVbN" );

		HDC hdc = ::GetDC( NULL );
		HFONT hOldFont = static_cast<HFONT>( ::SelectObject( hdc, hFont ) );

		char *c = cNum[ nNum ];
		UINT code = 0;
		if( ::IsDBCSLeadByte( *c ) )
			code = (BYTE)c[ 0 ] << 8 | (BYTE)c[ 1 ];
		else
			code = c[ 0 ];

		int nSize = ::GetGlyphOutline( hdc, code, GGO_GRAY8_BITMAP, &gm, 0, NULL, &mat );
		BYTE *pBuf = new BYTE[ nSize ];
		::GetGlyphOutline( hdc, code, GGO_GRAY8_BITMAP, &gm, nSize, pBuf, &mat );

		::SelectObject( hdc, hOldFont );
		::DeleteObject( hFont );
		::ReleaseDC( NULL, hdc );

		int nWMax = 16;
		int nHMax = 17;
		int nW = ( ( gm.gmBlackBoxX + 3 ) & 0xFFFFFFFC );
		int nH = gm.gmBlackBoxY;

		BYTE *pBuf2 = new BYTE[ nWMax * nHMax * 4 ];
		::memset( pBuf2, 0, nWMax * nHMax * 4 );
		for( int i = 0; i < nH; i++ )
			for( int j = 0, k = 0; k < nW; j+=4, k++ )
			{
				int nData1 = i * nWMax * 4 + j + ( nWMax - nW ) / 2;
				int nData2 =  i * nW + k;
				pBuf2[ nData1 + 0 ] = ( 255 * pBuf[ nData2 ] / 64 );
				pBuf2[ nData1 + 1 ] = ( 255 * pBuf[ nData2 ] / 64 );
				pBuf2[ nData1 + 2 ] = ( 255 * pBuf[ nData2 ] / 64 );
				pBuf2[ nData1 + 3 ] = ( 255 * pBuf[ nData2 ] / 64 );
			}

		delete pBuf;

		BITMAPINFOHEADER	Bi;
		Bi.biSize			= sizeof( BITMAPINFOHEADER );
		Bi.biWidth			= nWMax;
		Bi.biHeight			= nHMax;
		Bi.biPlanes			= 1;
		Bi.biBitCount		= 32;
		Bi.biCompression	= BI_RGB;
		Bi.biSizeImage		= nWMax * nHMax * 4;
		Bi.biXPelsPerMeter	= 0;
		Bi.biYPelsPerMeter	= 0;
		Bi.biClrUsed		= 0;
		Bi.biClrImportant	= 0;

		BITMAPFILEHEADER	Bf;
		::memset( &Bf, 0, sizeof( BITMAPFILEHEADER ) );
		Bf.bfType	= ('M'<<8)|'B';
		Bf.bfSize	= sizeof( BITMAPFILEHEADER ) + sizeof( BITMAPINFOHEADER ) + Bi.biSizeImage;
		Bf.bfOffBits= sizeof( BITMAPFILEHEADER ) + sizeof( BITMAPINFOHEADER );

		BYTE *pBuf3 = new BYTE[ Bf.bfSize ];
		nSize = 0;
		::memcpy_s( &pBuf3[ nSize ], sizeof( BITMAPFILEHEADER ), &Bf, sizeof( BITMAPFILEHEADER ) );
		nSize += sizeof( BITMAPFILEHEADER );
		::memcpy_s( &pBuf3[ nSize ], sizeof( BITMAPINFOHEADER ), &Bi, sizeof( BITMAPINFOHEADER ) );
		nSize += sizeof( BITMAPINFOHEADER );
		::memcpy_s( &pBuf3[ nSize ], Bi.biSizeImage, pBuf2, Bi.biSizeImage );
		delete pBuf2;

		g_pGraph->LoadMem( 100 + nNum, pBuf3, Bf.bfSize, 0x00000000 );
		delete pBuf3;
	}

	g_nGameCnt = eGameState_None;

	// 쐬
	Create();

	return TRUE;
}

/*******************************************************************************
 *	@fn				void KeyState( BYTE* byKey )
 *	@param[in]		byKey						L[obt@
 *	@retval			none						Ȃ
 *	@brief			L[
 ******************************************************************************/
void KeyState( BYTE* byKey )
{
	::memcpy_s( g_byKey, DL::CDLInput::KEYBUFFER_MAX, byKey, DL::CDLInput::KEYBUFFER_MAX );

	if( g_byKey[ DIK_ESCAPE ] & 0x80 )											//!< ESCL[
	{
		g_bProg = FALSE;
	}
}

/*******************************************************************************
 *	@fn				void Proc( BYTE* byKey,
 *							   DIMOUSESTATE* diMouse )
 *	@param[in]		byKey						L[obt@
 *	@param[in]		diMouse						}EXobt@
 *	@retval			none						Ȃ
 *	@brief			vO
 ******************************************************************************/
void Proc( BYTE* byKey, DIMOUSESTATE* diMouse )
{
	g_DIMS = *diMouse;

	// L[
	KeyState( byKey );

	// J[\
	::GetCursorPos( &g_ptMouse );
	::ScreenToClient( g_hWnd, &g_ptMouse );

	// Q[
	Game();

	// `
	Draw();
}

/*******************************************************************************
 *	@fn				int WINAPI WinMain( HINSTANCE hInstance,
 *									    HINSTANCE hPrevInstance,
 *										LPSTR lpCmdLine,
 *										int nCmdShow )
 *	@param[in]		hInstance		CX^Xnh
 *	@param[in]		hPrevInstance	CX^Xnh
 *	@param[in]		lpCmdLine		
 *	@param[in]		nCmdShow		
 *	@retval			LRESULT			
 *	@brief			vON
 ******************************************************************************/
int WINAPI WinMain( HINSTANCE hInstance,
				    HINSTANCE hPrevInstance,
					LPSTR lpCmdLine,
					int nCmdShow )
{
	// AvP[V̏
	if( Init( hInstance ) == EXIT_FAILURE ) return EXIT_FAILURE;
	// DirectXLibrary̏
	if( !Init() ) goto ERR_EXIT;

	// [v
	do
	{
		DL::Exec( Proc );
	} while( ProcessEvent() );

ERR_EXIT:
	// DirectXLibrary̏I
	DL::End();
	// AvP[V̏I
	Exit();

	return EXIT_SUCCESS;
}
